// Generated by gencpp from file franka_example_controllers/JointTorqueComparison.msg
// DO NOT EDIT!


#ifndef FRANKA_EXAMPLE_CONTROLLERS_MESSAGE_JOINTTORQUECOMPARISON_H
#define FRANKA_EXAMPLE_CONTROLLERS_MESSAGE_JOINTTORQUECOMPARISON_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace franka_example_controllers
{
template <class ContainerAllocator>
struct JointTorqueComparison_
{
  typedef JointTorqueComparison_<ContainerAllocator> Type;

  JointTorqueComparison_()
    : tau_error()
    , tau_commanded()
    , tau_measured()
    , F_ext_measured()
    , F_ext_desired()
    , F_ext_error()
    , root_mean_square_error(0.0)
    , time(0.0)
    , V_measured()
    , P_measured()  {
      tau_error.assign(0.0);

      tau_commanded.assign(0.0);

      tau_measured.assign(0.0);

      F_ext_measured.assign(0.0);

      F_ext_desired.assign(0.0);

      F_ext_error.assign(0.0);

      V_measured.assign(0.0);

      P_measured.assign(0.0);
  }
  JointTorqueComparison_(const ContainerAllocator& _alloc)
    : tau_error()
    , tau_commanded()
    , tau_measured()
    , F_ext_measured()
    , F_ext_desired()
    , F_ext_error()
    , root_mean_square_error(0.0)
    , time(0.0)
    , V_measured()
    , P_measured()  {
  (void)_alloc;
      tau_error.assign(0.0);

      tau_commanded.assign(0.0);

      tau_measured.assign(0.0);

      F_ext_measured.assign(0.0);

      F_ext_desired.assign(0.0);

      F_ext_error.assign(0.0);

      V_measured.assign(0.0);

      P_measured.assign(0.0);
  }



   typedef boost::array<double, 7>  _tau_error_type;
  _tau_error_type tau_error;

   typedef boost::array<double, 7>  _tau_commanded_type;
  _tau_commanded_type tau_commanded;

   typedef boost::array<double, 7>  _tau_measured_type;
  _tau_measured_type tau_measured;

   typedef boost::array<double, 6>  _F_ext_measured_type;
  _F_ext_measured_type F_ext_measured;

   typedef boost::array<double, 6>  _F_ext_desired_type;
  _F_ext_desired_type F_ext_desired;

   typedef boost::array<double, 6>  _F_ext_error_type;
  _F_ext_error_type F_ext_error;

   typedef double _root_mean_square_error_type;
  _root_mean_square_error_type root_mean_square_error;

   typedef double _time_type;
  _time_type time;

   typedef boost::array<double, 6>  _V_measured_type;
  _V_measured_type V_measured;

   typedef boost::array<double, 6>  _P_measured_type;
  _P_measured_type P_measured;





  typedef boost::shared_ptr< ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> const> ConstPtr;

}; // struct JointTorqueComparison_

typedef ::franka_example_controllers::JointTorqueComparison_<std::allocator<void> > JointTorqueComparison;

typedef boost::shared_ptr< ::franka_example_controllers::JointTorqueComparison > JointTorqueComparisonPtr;
typedef boost::shared_ptr< ::franka_example_controllers::JointTorqueComparison const> JointTorqueComparisonConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator1> & lhs, const ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator2> & rhs)
{
  return lhs.tau_error == rhs.tau_error &&
    lhs.tau_commanded == rhs.tau_commanded &&
    lhs.tau_measured == rhs.tau_measured &&
    lhs.F_ext_measured == rhs.F_ext_measured &&
    lhs.F_ext_desired == rhs.F_ext_desired &&
    lhs.F_ext_error == rhs.F_ext_error &&
    lhs.root_mean_square_error == rhs.root_mean_square_error &&
    lhs.time == rhs.time &&
    lhs.V_measured == rhs.V_measured &&
    lhs.P_measured == rhs.P_measured;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator1> & lhs, const ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace franka_example_controllers

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsFixedSize< ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> >
{
  static const char* value()
  {
    return "29dd5a2956690163cef52317ddda210d";
  }

  static const char* value(const ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x29dd5a2956690163ULL;
  static const uint64_t static_value2 = 0xcef52317ddda210dULL;
};

template<class ContainerAllocator>
struct DataType< ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> >
{
  static const char* value()
  {
    return "franka_example_controllers/JointTorqueComparison";
  }

  static const char* value(const ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float64[7] tau_error\n"
"float64[7] tau_commanded\n"
"float64[7] tau_measured\n"
"float64[6] F_ext_measured\n"
"float64[6] F_ext_desired\n"
"float64[6] F_ext_error\n"
"  float64 root_mean_square_error\n"
"  float64 time\n"
"float64[6] V_measured\n"
"float64[6] P_measured\n"
;
  }

  static const char* value(const ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.tau_error);
      stream.next(m.tau_commanded);
      stream.next(m.tau_measured);
      stream.next(m.F_ext_measured);
      stream.next(m.F_ext_desired);
      stream.next(m.F_ext_error);
      stream.next(m.root_mean_square_error);
      stream.next(m.time);
      stream.next(m.V_measured);
      stream.next(m.P_measured);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct JointTorqueComparison_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::franka_example_controllers::JointTorqueComparison_<ContainerAllocator>& v)
  {
    s << indent << "tau_error[]" << std::endl;
    for (size_t i = 0; i < v.tau_error.size(); ++i)
    {
      s << indent << "  tau_error[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.tau_error[i]);
    }
    s << indent << "tau_commanded[]" << std::endl;
    for (size_t i = 0; i < v.tau_commanded.size(); ++i)
    {
      s << indent << "  tau_commanded[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.tau_commanded[i]);
    }
    s << indent << "tau_measured[]" << std::endl;
    for (size_t i = 0; i < v.tau_measured.size(); ++i)
    {
      s << indent << "  tau_measured[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.tau_measured[i]);
    }
    s << indent << "F_ext_measured[]" << std::endl;
    for (size_t i = 0; i < v.F_ext_measured.size(); ++i)
    {
      s << indent << "  F_ext_measured[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.F_ext_measured[i]);
    }
    s << indent << "F_ext_desired[]" << std::endl;
    for (size_t i = 0; i < v.F_ext_desired.size(); ++i)
    {
      s << indent << "  F_ext_desired[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.F_ext_desired[i]);
    }
    s << indent << "F_ext_error[]" << std::endl;
    for (size_t i = 0; i < v.F_ext_error.size(); ++i)
    {
      s << indent << "  F_ext_error[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.F_ext_error[i]);
    }
    s << indent << "root_mean_square_error: ";
    Printer<double>::stream(s, indent + "  ", v.root_mean_square_error);
    s << indent << "time: ";
    Printer<double>::stream(s, indent + "  ", v.time);
    s << indent << "V_measured[]" << std::endl;
    for (size_t i = 0; i < v.V_measured.size(); ++i)
    {
      s << indent << "  V_measured[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.V_measured[i]);
    }
    s << indent << "P_measured[]" << std::endl;
    for (size_t i = 0; i < v.P_measured.size(); ++i)
    {
      s << indent << "  P_measured[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.P_measured[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // FRANKA_EXAMPLE_CONTROLLERS_MESSAGE_JOINTTORQUECOMPARISON_H
